Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# PGVirtualFrame Class Reference

This represents a frame that is rendered as a window onto another (possibly much larger) canvas. More...

Inheritance diagram for PGVirtualFrame:

List of all members.

## Public Member Functions
| PGVirtualFrame (string name)
| PGVirtualFrame ()
| clearClipFrame ()
| Removes the clip frame from the item.
PandaNode | getCanvasNode ()
| Returns the special node that holds all of the children that appear in the virtual canvas.
PandaNode | getCanvasParent ()
| Returns the parent node of the canvas_node.
TransformState const | getCanvasTransform ()
| Returns the transform of the virtual canvas.
VBase4 const | getClipFrame ()
| Returns the bounding rectangle of the clip frame.
bool | hasClipFrame ()
| Returns true if the clip frame has been set; see set_clip_frame().
| setCanvasTransform (TransformState const transform)
| Changes the transform of the virtual canvas.
| setClipFrame (VBase4 const clip_frame)
| Sets the bounding rectangle of the clip frame.
| setClipFrame (float left, float right, float bottom, float top)
| Sets the bounding rectangle of the clip frame.
| setup (float width, float height)
| Creates a PGVirtualFrame with the indicated dimensions.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This represents a frame that is rendered as a window onto another (possibly much larger) canvas.

You can only see the portion of the canvas that is below the window at any given time.

This works simply by automatically defining a scissor effect to be applied to a special child node, called the canvas_node, of the PGVirtualFrame node. Every object that is parented to the canvas_node will be clipped by the scissor effect. Also, you can modify the canvas_transform through convenience methods here, which actually modifies the transform on the canvas_node.

The net effect is that the virtual canvas is arbitrarily large, and we can peek at it through the scissor region, and scroll through different parts of it by modifying the canvas_transform.

See PGScrollFrame for a specialization of this class that handles the traditional scrolling canvas, with scroll bars.

## Constructor & Destructor Documentation

PGVirtualFrame | ( | string | name | ) |

PGVirtualFrame | ( |  | ) |

## Member Function Documentation

clearClipFrame | ( |  | ) |

Removes the clip frame from the item.

This disables clipping.

PandaNode getCanvasNode | ( |  | ) |

Returns the special node that holds all of the children that appear in the virtual canvas.

PandaNode getCanvasParent | ( |  | ) |

Returns the parent node of the canvas_node.

TransformState const getCanvasTransform | ( |  | ) |

Returns the transform of the virtual canvas.

This transform is applied to all child nodes of the canvas_node.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from PGItem.

Reimplemented in PGScrollFrame.

VBase4 const getClipFrame | ( |  | ) |

Returns the bounding rectangle of the clip frame.

See set_clip_frame(). If has_clip_frame() is false, this returns the item's actual frame.

bool hasClipFrame | ( |  | ) |

Returns true if the clip frame has been set; see set_clip_frame().

If it has not been set, objects in the virtual frame will not be clipped.

setCanvasTransform | ( | TransformState const | transform | ) |

Changes the transform of the virtual canvas.

This transform is applied to all child nodes of the canvas_node.

setClipFrame | ( | float | left,
|  | float | right,
|  | float | bottom,
|  | float | top
| ) |  |

Sets the bounding rectangle of the clip frame.

This is the size of the small window through which we can see the virtual canvas. Normally, this is the same size as the actual frame or smaller (typically it is smaller by the size of the bevel, or to make room for scroll bars).

setClipFrame | ( | VBase4 const | clip_frame | ) |

Sets the bounding rectangle of the clip frame.

This is the size of the small window through which we can see the virtual canvas. Normally, this is the same size as the actual frame or smaller (typically it is smaller by the size of the bevel, or to make room for scroll bars).

setup | ( | float | width,
|  | float | height
| ) |  |

Creates a PGVirtualFrame with the indicated dimensions.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties